### R code from vignette source 'editrules-as-mip.Rnw'

###################################################
### code chunk number 1: editrules-as-mip.Rnw:42-43
###################################################
library(editrules)


###################################################
### code chunk number 2: editrules-as-mip.Rnw:220-233
###################################################
E <- editmatrix(c(
    "x + y == z",
    "x > 0",
    "y > 0",
    "z > 0"))

dat <- data.frame(
    x = c(1,-1,1),
    y = c(-1,1,1),
    z = c(2,0,2))

# localize all errors in the data using mip
localizeErrors(E,dat, method="mip")


###################################################
### code chunk number 3: editrules-as-mip.Rnw:373-380
###################################################
E <- cateditmatrix( 
       expression( gender %in% c("male", "female")
                 , if (pregnant) gender == "female"
                 )
                  )
as.data.frame(E)
getAb(E)


###################################################
### code chunk number 4: editrules-as-mip.Rnw:392-394
###################################################
dat <- data.frame(gender="male", pregnant=TRUE)
localizeErrors(E,dat, method="mip")


