### R code from vignette source 'editrules-categorical.Rnw'

###################################################
### code chunk number 1: editrules-categorical.Rnw:72-73
###################################################
library(editrules)


###################################################
### code chunk number 2: editrules-categorical.Rnw:284-292
###################################################
E <- editarray(c(
    "gender %in% c('male','female')",
    "pregnant %in% c('yes','no')",
    "if (gender == 'male') pregnant == 'no'"
    )
)
E
datamodel(E)


###################################################
### code chunk number 3: editrules-categorical.Rnw:399-406
###################################################
xval <- letters[1:4]
yval <- c(TRUE,FALSE)
( M <- editarray(c( 
    "x %in% xval",
    "y %in% yval",
    "if ( x %in% c('a','b') ) !y "
    )) )


###################################################
### code chunk number 4: editrules-categorical.Rnw:422-423
###################################################
as.character(M,useIf=FALSE)


###################################################
### code chunk number 5: editrules-categorical.Rnw:541-547
###################################################
M <- editarray(c(
    "x %in% c('a','b')",
    "y %in% c('c','d')",
    "if ( x == 'a' ) y == 'c'",
    "if ( x == 'a' ) y != 'c'"))



###################################################
### code chunk number 6: editrules-categorical.Rnw:550-551
###################################################
isFeasible(M)


###################################################
### code chunk number 7: editrules-categorical.Rnw:555-556
###################################################
isFeasible(substValue(M,'x','a'))


###################################################
### code chunk number 8: editrules-categorical.Rnw:610-611
###################################################
substValue(E,"gender","female")


###################################################
### code chunk number 9: editrules-categorical.Rnw:617-618
###################################################
substValue(E,"gender","female",reduce=TRUE)


###################################################
### code chunk number 10: editrules-categorical.Rnw:623-624
###################################################
reduce(substValue(E,"gender","female"))


###################################################
### code chunk number 11: editrules-categorical.Rnw:678-685
###################################################
E <- editarray(c(
    "age %in% c('under-aged','adult')",
    "maritalStatus %in% c('married','not married')",
    "positionInHousehold %in% c('spouse','child','other')",
    "if (age == 'under-aged') maritalStatus != 'married'",
    "if (positionInHousehold == 'spouse') maritalStatus == 'married'"
))


###################################################
### code chunk number 12: editrules-categorical.Rnw:688-689
###################################################
eliminate(E,'maritalStatus')


###################################################
### code chunk number 13: editrules-categorical.Rnw:692-693
###################################################
eliminate(E,'age')


###################################################
### code chunk number 14: editrules-categorical.Rnw:978-994
###################################################
E <- editarray(c(
    "age %in% c('under-aged','adult')",
    "maritalStatus %in% c('unmarried','married','widowed','divorced')",
    "positionInHousehold %in% c('spouse', 'child', 'other')",
    "if( age == 'under-aged' ) maritalStatus == 'unmarried'",
    "if(positionInHousehold == 'spouse') maritalStatus == 'married'"
    )
)

(dat <- data.frame(
    maritalStatus=c('married','unmarried','widowed' ), 
    age = c('under-aged','adult','adult' ),
    positionInHousehold=c('child','spouse','other')
))
set.seed(1)
localizeErrors(E,dat)


###################################################
### code chunk number 15: editrules-categorical.Rnw:1021-1026
###################################################
(dat <- data.frame(
    maritalStatus=c('married','unmarried','widowed' ), 
    age = c('under-aged','adult','adult' ),
    positionInHousehold=c('child','spouse','other')
))


###################################################
### code chunk number 16: editrules-categorical.Rnw:1061-1072
###################################################
record <- c( 
    age = 'under-aged', 
    maritalStatus='married', 
    positionInHousehold='child'
)
el <- errorLocalizer(E,record)
el$searchNext()
el$duration
el$maxdurationExceeded
el$searchNext()
el$searchNext()


